﻿Imports System
Imports System.Threading
Imports System.Runtime.InteropServices




Module Module1
    Public RDat(4096) As Byte
    <DllImport("KERNEL32.DLL")> _
    Public Function WritePrivateProfileString( _
        ByVal lpAppName As String, _
        ByVal lpKeyName As String, _
        ByVal lpString As String, _
        ByVal lpFileName As String) As Integer
    End Function

    <DllImport("KERNEL32.DLL", CharSet:=CharSet.Auto)> _
    Public Function GetPrivateProfileString( _
        ByVal lpAppName As String, _
        ByVal lpKeyName As String, ByVal lpDefault As String, _
        ByVal lpReturnedString As System.Text.StringBuilder, _
        ByVal nSize As Integer, _
        ByVal lpFileName As String) As Integer
    End Function

    <DllImport("KERNEL32.DLL", CharSet:=CharSet.Auto)> _
    Public Function GetPrivateProfileInt( _
      ByVal lpAppName As String, _
      ByVal lpKeyName As String, ByVal nDefault As Integer, _
      ByVal lpFileName As String) As Integer
    End Function



    Sub P6(ByVal dat%)
        Dim dum As String

        dum = "wr ff06 " & Hex(dat) & vbCr              ' 引数をff06番地(P6)に書込む命令
        Try
            Form1.SerialPort1.Write(dum)                ' 命令をUSBマイコンに送信
        Catch ex As Exception
            MessageBox.Show(ex.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Sub P1(ByVal dat%)
        Dim dum As String

        dum = "wr ff01 " & Hex(dat) & vbCr
        Try
            Form1.SerialPort1.Write(dum)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Sub PM1(ByVal dat%)
        Dim dum As String

        dum = "wr ff21 " & Hex(dat) & vbCr
        Try
            Form1.SerialPort1.Write(dum)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Sub PU1(ByVal dat%)
        Dim dum As String

        dum = "wr ff31 " & Hex(dat) & vbCr
        Try
            Form1.SerialPort1.Write(dum)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Function P1R() As Integer
        Dim strDataReceived As String
        '      Dim Dat(4096) As Byte
        Dim Rnum As Integer
        Dim i As Integer
        Dim dum As String

        Form1.SerialPort1.ReceivedBytesThreshold = 1000         ' SerialPort1データ受信割込みを禁止
        dum = "dump ff01 1" & vbCr                              ' P1レジスタの読込み命令
        Try
            Form1.SerialPort1.Write(dum)                        ' USBマイコンに送信
        Catch ex As Exception
            MessageBox.Show(ex.Message, "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        Try
            Do While (1)
                Rnum = Form1.SerialPort1.BytesToRead            ' 受信バイト数の取得
                Thread.Sleep(2)                                 ' 2ms間待つ
                If Rnum = Form1.SerialPort1.BytesToRead Then Exit Do ' 受信バイト数が増えなくなったらループを抜ける
            Loop
            For i = 0 To Rnum - 1
                RDat(i) = Form1.SerialPort1.ReadByte            ' 受信したデータを全て読込む
            Next
        Catch ex As Exception
            strDataReceived = ex.Message
        End Try
        Form1.SerialPort1.ReceivedBytesThreshold = 1            ' SerialPort1データ受信割込みを許可
        i = Val("&h" & Chr(RDat(&H12)) & Chr(RDat(&H13)))       ' ff01番地のデータだけを抽出
        Return i                                                ' データをリターン

    End Function

    Function Hex0(ByVal Num As Byte) As String

        Select Case Num
            Case Is < 16
                Hex0 = "0" & Hex(Num)
            Case Else
                Hex0 = Hex(Num)
        End Select
    End Function

End Module
